import levelObjects

def loadGoodShots():
    f=open("goodShots.txt")

    shotTuples=[]
    
    for shotLine in f.readlines():
        splitup=shotLine.split("|")
        levelNum=int(splitup[0])
        srcName=splitup[1]
        destName=splitup[2]
        power=float(splitup[3])
        angle=float(splitup[4])

        shotTuples.append({"level":levelNum,
                           "src":srcName,
                           "dest":destName,
                           "power":power,
                           "angle":angle})
    return shotTuples


def findObject(level, name):
    objectList=levelObjects.objs[level]

    for o in objectList:
        if o["name"]==name:
            return o
    return None

def findObjects(st):
    objectList=levelObjects.objs[st["level"]]

    srcObj=None
    destObj=None

    for o in objectList:
        if o["name"]==st["src"]:
            srcObj=o
        if o["name"]==st["dest"]:
            destObj=o
    return (srcObj, destObj)
        
            


def filterOutGasAndOrbit(st):
    newSt=[]

    for s in st:
        #print
        #print s
        src,dest=findObjects(s)

        #print src,dest

        if ((src is None) or (dest is None)):
            # wtf?!
            #assert(0)
            continue
        isGood=True
        for p in [src,dest]:
            if p.get("gaseous", False):
                isGood=False
            if p.get("orbits", False):
                isGood=False
        if isGood:
            newSt.append(s)
    return newSt

def getScoringShots(st):
    newSt=[]
    
    for s in st:
        o=findObject(s["level"],
                     s["dest"])
        if o.get("target",False):
            newSt.append(s)
    return newSt
        
    


st=loadGoodShots()
print st[0]
print "before filter:",len(st)
st=filterOutGasAndOrbit(st)
print "after filter:",len(st)

st=getScoringShots(st)
print "just scoring:",len(st)

sortedShotList=[(x["level"],x) for x in st]
sortedShotList.sort()

#shotDict[<levelNum>][<srcName>] ==> [(a1, p1), (a2,p2), ...]
shotDict={}


for levNum,s in sortedShotList:
    levelInfo=shotDict.get(levNum,{})
    planetInfo=levelInfo.get(s["src"],[])

    shotInfo=s["angle"],s["power"]
    
    planetInfo.append(shotInfo)
    levelInfo[s["src"]]=planetInfo
    shotDict[s["level"]]=levelInfo

    #print s


for level in shotDict.keys():
    print
    print "levels[%d]={"%level
    for src in shotDict[level].keys():
        print '     "%s":['%src
        for sd in shotDict[level][src]:
            print '        (%.8f, %.8f),'%sd
        print '        ],'
    print '    }'
    
    
        
    


