import Image



def getCrossings(im, y):
    lastPixel=im.getpixel((0,y))

    crossings=[]
    
    for x in range(400):
        pix=im.getpixel((x,y))
        #print pix,

        delta=pix-lastPixel

        if abs(delta)>128:
            crossings.append(2*x)
            
            if delta>0:
                # must be white now
                lastPixel=255
            else:
                lastPixel=0

    print y,crossings
    return crossings


def makeEdgeList(imFilename, destFilename):
    destFile=open(destFilename,"wt")
    im=Image.open(imFilename).convert("L")
    im.save("fooMask.png")

    destFile.write("lines={\n")
    for y in range(0,300,2):
        crossings=getCrossings(im,y)
        if crossings:
            destLine=(300-y)*2
            destFile.write("    %d : %s,\n"%(destLine,str(crossings)))
    destFile.write("}\n\n")
    




makeEdgeList("../Reference/upMask.png","edgesUp.py")
makeEdgeList("../Reference/packageMask.png","edgesPackage.py")
makeEdgeList("../Reference/bdg.png","edgesBDG.py")
makeEdgeList("../Reference/pyweek4Mask1.png","edgesPW4_1.py")
makeEdgeList("../Reference/pyweek4mask2.png","edgesPW4_2.py")
makeEdgeList("../Reference/tigerWoodsMask.png","edgesWoody.py")
makeEdgeList("../Reference/logoMask.png","edgesLogo.py")
makeEdgeList("../Reference/towerMask.png","edgesTower.py")
makeEdgeList("../Reference/menuMask.png","edgesMenu.py")
             
