import math
import sys

from OpenGL.GL import *
from OpenGL.GLU import *
import pygame, pygame.image
from pygame.locals import *

import fsmMgr
import mouseInfo

import statePlayAd
import stateDialog
import level1
import stateAim
import edgesMenu
import widgets
import tutorialProgress
import playerMgr
import stateMainMenu
import screenInfo
import fade       
import stateMainMenu

import tutorialProgress
import textDraw
import soundMgr

import levelIntros

gNumHumans=1
gNumAI=2


def pressHumansMinus():
    global gNumHumans
    gNumHumans -= 1
    if gNumHumans <0:
        gNumHumans = 0

def pressHumansPlus():
    global gNumHumans
    gNumHumans += 1


def pressAIMinus():
    global gNumAI
    gNumAI -= 1
    if gNumAI <0:
        gNumAI = 0

def pressAIPlus():
    global gNumAI
    gNumAI += 1



def pressPlay():
    fsmMgr.popAll()

    tutorialProgress.gTutorial=False
    playerMgr.initPlayers(gNumHumans, gNumAI)
    level1.thisLevel.setLevel(10)
    
    fsmMgr.pushState(level1.thisLevel)
    fsmMgr.pushState(stateAim.StateAim(None))

    introText=levelIntros.intros.get(10,None)
    if introText:
        title="Level %2d"%1
        fsmMgr.pushState(stateDialog.StateDialog((title,introText)))
                
                    

    
    

def pressCancel():
    fsmMgr.popAll()
    fsmMgr.pushState(stateMainMenu.StateMainMenu(None))


class StateNewGameMenu(fsmMgr.State):
    def __init__(self, data):
        fsmMgr.State.__init__(self)

        self.clicked=False

        self.left=180
        self.right=620
        self.top=450
        self.bottom=150

        B=(50-32)/2
        self.widgets=[widgets.Button(300,300+B,8,"-",pressHumansMinus),
                      widgets.Button(500,300+B,8,"+",pressHumansPlus),
                      widgets.Button(300,200+B,8,"-",pressAIMinus),
                      widgets.Button(500,200+B,8,"+",pressAIPlus),
                      widgets.Button(300,150+B,8,"CANCEL", pressCancel),
                      widgets.Button(500,150+B,8,"OK", pressPlay)
                      ]

        for w in self.widgets[:4]:
            w.setWidth(50)
        for w in self.widgets[4:]:
            w.setWidth(180)

        for w in self.widgets:
            w.x=w.x-w.width/2
            w.makeDL()

    def update(self, dt):
        dt=dt/1000.0

        mouseInfo.readMouse()
        for w in self.widgets:
            w.update(dt)

    def draw(self):
        glColor3f(0,0,0)
        glBegin(GL_QUADS)
        glVertex(self.left,self.bottom)
        glVertex(self.right,self.bottom)
        glVertex(self.right,self.top)
        glVertex(self.left,self.top)
        glEnd()

        glColor3f(*fade.DIM_COLOR)
        glBegin(GL_LINE_LOOP)
        glVertex(self.left,self.bottom)
        glVertex(self.right,self.bottom)
        glVertex(self.right,self.top)
        glVertex(self.left,self.top)
        glEnd()
        
        for w in self.widgets:
            w.draw()

        B=(50-32)/2

        textDraw.drawCenteredString(400,425-B,
                                    fade.DIM_COLOR,
                                    8,
                                    "HOW MANY PLAYERS?")

        textDraw.drawCenteredString(400,375-B,
                                    fade.DIM_COLOR,
                                    8,
                                    "HUMANS")

        textDraw.drawCenteredString(400,325-B,
                                    fade.DIM_COLOR,
                                    8,
                                    str(gNumHumans))        

        textDraw.drawCenteredString(400,275-B,
                                    fade.DIM_COLOR,
                                    8,
                                    "CPU")

        textDraw.drawCenteredString(400,225-B,
                                    fade.DIM_COLOR,
                                    8,
                                    str(gNumAI))
        
        if fsmMgr.isTop(self):
            widgets.drawCursor()

        

            

    def handleMouseButton(self, bDown, buttonIndex):
        mouseInfo.readMouse()
        if bDown and buttonIndex==1:
            for w in self.widgets:
                if w.isMouseInMe():
                    soundMgr.playSound("ping")
                    w.callbackFunc()
        return True

    def done(self):
        fsmMgr.popState()

    

